const config = require('../../config');
const providers = config.providers;
const crypto = require('crypto');
const bcrypt = require('bcrypt');
const moment = require('moment');

module.exports = function(sequelize, DataTypes) {
  const nursing_staff = sequelize.define(
    'nursing_staff',
    {
      id: {
        type: DataTypes.UUID,
        defaultValue: DataTypes.UUIDV4,
        primaryKey: true,
      },

full_name: {
        type: DataTypes.TEXT,
      
      

      },

national_number: {
        type: DataTypes.TEXT,
      
      

      },

specialty: {
        type: DataTypes.TEXT,
      
      

      },

address: {
        type: DataTypes.TEXT,
      
      

      },

phone: {
        type: DataTypes.TEXT,
      
      

      },

marital_status: {
        type: DataTypes.ENUM,
      
      

        values: [

"single",


"married",


"widowed",


"divorced"

        ],

      },

children_count: {
        type: DataTypes.INTEGER,
      
      

      },

night_shifts: {
        type: DataTypes.BOOLEAN,
      
        allowNull: false,
        defaultValue: false,
      
      

      },

salary: {
        type: DataTypes.DECIMAL,
      
      

      },

bonuses: {
        type: DataTypes.DECIMAL,
      
      

      },

hire_date: {
        type: DataTypes.DATE,
      
      

      },

      importHash: {
        type: DataTypes.STRING(255),
        allowNull: true,
        unique: true,
      },
    },
    {
      timestamps: true,
      paranoid: true,
      freezeTableName: true,
    },
  );

  nursing_staff.associate = (db) => {


/// loop through entities and it's fields, and if ref === current e[name] and create relation has many on parent entity




































    db.nursing_staff.hasMany(db.room_bookings, {
      as: 'room_bookings_supervising_nurse',
      foreignKey: {
          name: 'supervising_nurseId',
      },
      constraints: false,
    });











//end loop






    db.nursing_staff.belongsTo(db.users, {
      as: 'createdBy',
    });

    db.nursing_staff.belongsTo(db.users, {
      as: 'updatedBy',
    });
  };



  return nursing_staff;
};


